import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

public class TimerIC extends JPanel implements ActionListener{
	JLabel onTime, offTime;
	JTextField r1, r2, c1;
	Teiko teiko;
	JComboBox unit1,unit2, unit3, unitT1, unitT2; 
	JButton btn1;
	
	TimerIC(){
		setBackground(Color.white);
		r1 = new JTextField(10);
		r2 = new JTextField(10);
		c1 = new JTextField(10);
		String list[] = {"M", "k", ""};
		String list2[] = {"F", "uF", "pF"};
		String list3[] = {"s", "ms"};
		unit1 = new JComboBox(list);
		unit2 = new JComboBox(list);
		unit3 = new JComboBox(list2);
		unitT1 = new JComboBox(list3);
		unitT2 = new JComboBox(list3);
		unit1.setSelectedIndex(1);
		unit2.setSelectedIndex(1);
		unit3.setSelectedIndex(1);
		onTime = new JLabel();
		offTime = new JLabel();
		btn1 = new JButton("NA");
		r1.addActionListener(this);
		r2.addActionListener(this);
		c1.addActionListener(this);
		btn1.addActionListener(this);
		setLayout(new GridLayout(6, 3));
		add(new JLabel("R1"));
		add(r1);
		add(unit1);
		add(new JLabel("R2"));
		add(r2);
		add(unit2);
		add(new JLabel("C1"));
		add(c1);
		add(unit3);
		add(new JLabel("_"));
		add(onTime);
		add(unitT1);
		add(new JLabel(""));
		add(offTime);
		add(unitT2);
		add(btn1);
		
		teiko = new Teiko(-1.0, -1.0);
	}
	
	public void actionPerformed(ActionEvent e){
		Object obj = e.getSource();
		
		if(obj == r1 || obj == r2 || obj ==c1){
		
		double d,f;
		
		try{
			d = Double.parseDouble(r1.getText());
		}catch (NumberFormatException error){ d = -1.0;}
		if(unit1.getSelectedIndex()==0){
			d = d * 1000000;
		}else if(unit1.getSelectedIndex()==1){
			d = d * 1000;
		}else {
		}
		try{
			f = Double.parseDouble(c1.getText());
		}catch (NumberFormatException error){ f = -1.0;}
		
		switch (unit3.getSelectedIndex()){
			case 1:
				f *= 1e-6;
				break;
			case 2:
				f *= 1e-12;
				break;
		}
		
		teiko.setC1(f);
		teiko.setR1(d);
		
		try{
			d = Double.parseDouble(r2.getText());
		}catch (NumberFormatException error){ d = -1.0;}
		if(unit2.getSelectedIndex()==0){
			d = d * 1000000;
		}else if(unit2.getSelectedIndex()==1){
			d = d * 1000;
		}else {
		}
		
		
		
		teiko.setR2(d);
		
		doCalc();
		
		}else if(obj == btn1){
			clearText();
		}
		
		
		
		
	}
	
	void doCalc(){
		if(teiko.getR1() < 0){
			r1.requestFocus();
		}else if(teiko.getR2() < 0){
			r2.requestFocus();
		}else if(teiko.getC1() < 0){
			c1.requestFocus();
		}else {
			double on = teiko.calcOnTime();
			double off = teiko.calcOffTime();
			
			switch (unitT1.getSelectedIndex()){
				case 1:
				on *= 1e3;
				break;
			}
			
			switch (unitT2.getSelectedIndex()){
				case 1:
				off *= 1e3;
				break;
			}
			
			
			onTime.setText(Double.toString(on));
			offTime.setText(Double.toString(off));
		}
	}
	
	void clearText(){
		r1.setText("");
		r2.setText("");
		c1.setText("");
		onTime.setText("");
		offTime.setText("");
		r1.requestFocus();
	}
	
	
	public static void main(String args[]){
		JFrame f = new JFrame("_EԌvZ@");
		TimerIC h = new TimerIC();
		Container c = f.getContentPane();
		c.add(h, BorderLayout.CENTER);
		f.pack();
		f.setVisible(true);
		f.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
	}
}