import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

public class TimerIC2 extends JPanel implements ActionListener{
	JLabel onTime, offTime;
	JTextField r1, r2, c1;
	Teiko2 teiko;
	JComboBox unit1,unit2, unit3, unitT1, unitT2; 
	JButton btn1;

	TimerIC2(){
		setBackground(Color.white);
		r1 = new JTextField(10);
		r2 = new JTextField(10);
		c1 = new JTextField(10);
		
		String list[] = {"M", "k", ""};
		String list2[] = {"F", "uF", "pF"};
		String list3[] = {"s", "ms"};
		unit1 = new JComboBox(list);
		unit2 = new JComboBox(list);
		unit3 = new JComboBox(list2);
		unitT1 = new JComboBox(list3);
		unitT2 = new JComboBox(list3);
		unit1.setSelectedIndex(1);
		unit2.setSelectedIndex(1);
		unit3.setSelectedIndex(1);
		onTime = new JLabel();
		offTime = new JLabel();
		btn1 = new JButton("NA");
		r1.addActionListener(this);
		r2.addActionListener(this);
		c1.addActionListener(this);
		btn1.addActionListener(this);
		setLayout(new GridLayout(6, 3));
		add(new JLabel("_"));
		add(r1);
		add(unitT1);
		add(new JLabel(""));
		add(r2);
		add(unitT2);
		add(new JLabel("C1"));
		add(c1);
		add(unit3);
		add(new JLabel("R1"));
		add(onTime);
		add(unit1);
		add(new JLabel("R2"));
		add(offTime);
		add(unit2);
		add(btn1);

		teiko = new Teiko2(-1.0, -1.0);
	}
	
	public void actionPerformed(ActionEvent e){
		Object obj = e.getSource();
		if (obj == r1 || obj == r2 || obj ==c1){
		double d;
		try{
			d = Double.parseDouble(r1.getText());
		}catch (NumberFormatException error){ d = -1.0;}
		
		if(unitT1.getSelectedIndex()==1){
			d  *= 1e-3;
		}

		teiko.setR1(d);
		
		try{
			d = Double.parseDouble(r2.getText());
		}catch (NumberFormatException error){ d = -1.0;}

		if(unitT2.getSelectedIndex()==1){
			d *= 1e-3;
		}


		teiko.setR2(d);
		
		double f;
		
		try{
			f = Double.parseDouble(c1.getText());
		}catch (NumberFormatException error){ f = -1.0;}
		
		switch (unit3.getSelectedIndex()){
			case 1:
			f *= 1e-6;
			break;
			
			case 2:
			f *= 1e-12;
			break;
		}
		
		teiko.setC1(f);
		
		doCalc();
	}else {
		clearText();
	}
	}
	
	void doCalc(){
		double d, e;
		if(teiko.getR1() < 0){
//			r1.setText("");
			r1.requestFocus();
		}else if(teiko.getR2() < 0){
//			r2.setText("");
			r2.requestFocus();
		}else if(teiko.getC1() < 0){
			c1.requestFocus();
		}else {
		d = teiko.calcOnTime();
		e = teiko.calcOffTime();
		if(unit1.getSelectedIndex()==0){
			d = d / 1000000;
		}else if(unit1.getSelectedIndex()==1){
			d = d / 1000;
		}else {
		}
		
		if(unit2.getSelectedIndex()==0){
			e = e / 1000000;
		}else if(unit2.getSelectedIndex()==1){
			e = e / 1000;
		}else{
		}
		
			onTime.setText(Double.toString(d));
			offTime.setText(Double.toString(e));
		}
	}

	void clearText(){
		r1.setText("");
		r2.setText("");
		c1.setText("");
		onTime.setText("");
		offTime.setText("");
		r1.requestFocus();
	}
	
	public static void main(String args[]){
		JFrame f = new JFrame("RlvZ@");
		TimerIC2 h = new TimerIC2();
		Container c = f.getContentPane();
		c.add(h, BorderLayout.CENTER);
		f.pack();
		f.setVisible(true);
		f.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
	}
}